# coding: utf-8

"""
    Orbipay-Checkout APIs

    API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 

    OpenAPI spec version: 1.0.0
    Contact: checkout.orbipay@alacriti.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Address(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address_line1': 'str',
        'address_line2': 'str',
        'address_city': 'str',
        'address_state': 'str',
        'address_country': 'str',
        'address_zip1': 'str',
        'address_zip2': 'str'
    }

    attribute_map = {
        'address_line1': 'address_line1',
        'address_line2': 'address_line2',
        'address_city': 'address_city',
        'address_state': 'address_state',
        'address_country': 'address_country',
        'address_zip1': 'address_zip1',
        'address_zip2': 'address_zip2'
    }

    def __init__(self, address_line1=None, address_line2=None, address_city=None, address_state=None, address_country=None, address_zip1=None, address_zip2=None):
        """
        AddressInfo - a model defined in Swagger
        """

        self._address_line1 = None
        self._address_line2 = None
        self._address_city = None
        self._address_state = None
        self._address_country = None
        self._address_zip1 = None
        self._address_zip2 = None

        self.address_line1 = address_line1
        if address_line2 is not None:
          self.address_line2 = address_line2
        self.address_city = address_city
        self.address_state = address_state
        self.address_country = address_country
        self.address_zip1 = address_zip1
        if address_zip2 is not None:
          self.address_zip2 = address_zip2

    @property
    def address_line1(self):
        """
        Gets the address_line1 of this AddressInfo.

        :return: The address_line1 of this AddressInfo.
        :rtype: str
        """
        return self._address_line1

    @address_line1.setter
    def address_line1(self, address_line1):
        """
        Sets the address_line1 of this AddressInfo.

        :param address_line1: The address_line1 of this AddressInfo.
        :type: str
        
        if address_line1 is None:
            raise ValueError("Invalid value for `address_line1`, must not be `None`")
        if address_line1 is not None and len(address_line1) > 50:
            raise ValueError("Invalid value for `address_line1`, length must be less than or equal to `50`")
        if address_line1 is not None and len(address_line1) < 0:
            raise ValueError("Invalid value for `address_line1`, length must be greater than or equal to `0`")
        if address_line1 is not None and not re.search('^[a-zA-Z0-9\\,\\.\\#\\-\\s]+$', address_line1):
            raise ValueError("Invalid value for `address_line1`, must be a follow pattern or equal to `/^[a-zA-Z0-9\\,\\.\\#\\-\\s]+$/`")
        """
        self._address_line1 = address_line1

    @property
    def address_line2(self):
        """
        Gets the address_line2 of this AddressInfo.

        :return: The address_line2 of this AddressInfo.
        :rtype: str
        """
        return self._address_line2

    @address_line2.setter
    def address_line2(self, address_line2):
        """
        Sets the address_line2 of this AddressInfo.

        :param address_line2: The address_line2 of this AddressInfo.
        :type: str
        
        if address_line2 is not None and len(address_line2) > 50:
            raise ValueError("Invalid value for `address_line2`, length must be less than or equal to `50`")
        if address_line2 is not None and len(address_line2) < 0:
            raise ValueError("Invalid value for `address_line2`, length must be greater than or equal to `0`")
        if address_line2 is not None and not re.search('^[a-zA-Z0-9\\,\\.\\#\\-\\s]+$', address_line2):
            raise ValueError("Invalid value for `address_line2`, must be a follow pattern or equal to `/^[a-zA-Z0-9\\,\\.\\#\\-\\s]+$/`")
        """
        self._address_line2 = address_line2

    @property
    def address_city(self):
        """
        Gets the address_city of this AddressInfo.

        :return: The address_city of this AddressInfo.
        :rtype: str
        """
        return self._address_city

    @address_city.setter
    def address_city(self, address_city):
        """
        Sets the address_city of this AddressInfo.

        :param address_city: The address_city of this AddressInfo.
        :type: str
        
        if address_city is None:
            raise ValueError("Invalid value for `address_city`, must not be `None`")
        if address_city is not None and len(address_city) > 20:
            raise ValueError("Invalid value for `address_city`, length must be less than or equal to `20`")
        if address_city is not None and len(address_city) < 0:
            raise ValueError("Invalid value for `address_city`, length must be greater than or equal to `0`")
        if address_city is not None and not re.search('^[a-zA-Z0-9\\,\\.\\\'\\-_\\s]+$', address_city):
            raise ValueError("Invalid value for `address_city`, must be a follow pattern or equal to `/^[a-zA-Z0-9\\,\\.\\'\\-_\\s]+$/`")
        """
        self._address_city = address_city

    @property
    def address_state(self):
        """
        Gets the address_state of this AddressInfo.

        :return: The address_state of this AddressInfo.
        :rtype: str
        """
        return self._address_state

    @address_state.setter
    def address_state(self, address_state):
        """
        Sets the address_state of this AddressInfo.

        :param address_state: The address_state of this AddressInfo.
        :type: str

        if address_state is None:
            raise ValueError("Invalid value for `address_state`, must not be `None`")
        if address_state is not None and len(address_state) > 2:
            raise ValueError("Invalid value for `address_state`, length must be less than or equal to `2`")
        if address_state is not None and len(address_state) < 0:
            raise ValueError("Invalid value for `address_state`, length must be greater than or equal to `0`")
        if address_state is not None and not re.search('^[a-zA-Z0-9]{2}$', address_state):
            raise ValueError("Invalid value for `address_state`, must be a follow pattern or equal to `/^[a-zA-Z0-9]{2}$/`")
        """
        self._address_state = address_state

    @property
    def address_country(self):
        """
        Gets the address_country of this AddressInfo.
        The 3 digit ISO country code.

        :return: The address_country of this AddressInfo.
        :rtype: str
        """
        return self._address_country

    @address_country.setter
    def address_country(self, address_country):
        """
        Sets the address_country of this AddressInfo.
        The 3 digit ISO country code.

        :param address_country: The address_country of this AddressInfo.
        :type: str

        if address_country is None:
            raise ValueError("Invalid value for `address_country`, must not be `None`")
        if address_country is not None and len(address_country) > 3:
            raise ValueError("Invalid value for `address_country`, length must be less than or equal to `3`")
        if address_country is not None and len(address_country) < 3:
            raise ValueError("Invalid value for `address_country`, length must be greater than or equal to `3`")
        if address_country is not None and not re.search('^[a-zA-Z]{3}$', address_country):
            raise ValueError("Invalid value for `address_country`, must be a follow pattern or equal to `/^[a-zA-Z]{3}$/`")
        """

        self._address_country = address_country

    @property
    def address_zip1(self):
        """
        Gets the address_zip1 of this AddressInfo.

        :return: The address_zip1 of this AddressInfo.
        :rtype: str
        """
        return self._address_zip1

    @address_zip1.setter
    def address_zip1(self, address_zip1):
        """
        Sets the address_zip1 of this AddressInfo.

        :param address_zip1: The address_zip1 of this AddressInfo.
        :type: str
        """
        if address_zip1 is None:
            raise ValueError("Invalid value for `address_zip1`, must not be `None`")
        if address_zip1 is not None and not re.search('^[a-zA-Z0-9]{0,5}$', address_zip1):
            raise ValueError("Invalid value for `address_zip1`, must be a follow pattern or equal to `/^[a-zA-Z0-9]{0,5}$/`")

        self._address_zip1 = address_zip1

    @property
    def address_zip2(self):
        """
        Gets the address_zip2 of this AddressInfo.

        :return: The address_zip2 of this AddressInfo.
        :rtype: str
        """
        return self._address_zip2

    @address_zip2.setter
    def address_zip2(self, address_zip2):
        """
        Sets the address_zip2 of this AddressInfo.

        :param address_zip2: The address_zip2 of this AddressInfo.
        :type: str

        if address_zip2 is not None and not re.search('^[a-zA-Z0-9]{0,4}$', address_zip2):
            raise ValueError("Invalid value for `address_zip2`, must be a follow pattern or equal to `/^[a-zA-Z0-9]{0,4}$/`")
        """

        self._address_zip2 = address_zip2

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Address):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
