# coding: utf-8

"""
    Orbipay-Checkout APIs

    API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 

    OpenAPI spec version: 1.0.0
    Contact: checkout.orbipay@alacriti.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class InlineResponse2001CustomerAccountInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'customer_account_id': 'str',
        'custom_fields': 'object'
    }

    attribute_map = {
        'id': 'id',
        'customer_account_id': 'customer_account_id',
        'custom_fields': 'custom_fields'
    }

    def __init__(self, id=None, customer_account_id=None, custom_fields=None):
        """
        InlineResponse2001CustomerAccountInfo - a model defined in Swagger
        """

        self._id = None
        self._customer_account_id = None
        self._custom_fields = None

        if id is not None:
            self.id = id
        if customer_account_id is not None:
            self.customer_account_id = customer_account_id
        if custom_fields is not None:
            self.custom_fields = custom_fields

    @property
    def id(self):
        """
        Gets the id of this InlineResponse2001CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in OrbiPay-Checkout

        :return: The id of this InlineResponse2001CustomerAccountInfo.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this InlineResponse2001CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in OrbiPay-Checkout

        :param id: The id of this InlineResponse2001CustomerAccountInfo.
        :type: str
        """
        if id is not None and len(id) > 50:
            raise ValueError("Invalid value for `id`, length must be less than or equal to `50`")
        if id is not None and len(id) < 0:
            raise ValueError("Invalid value for `id`, length must be greater than or equal to `0`")
        if id is not None and not re.search('^[A-Za-z0-9-_]{0,50}$', id):
            raise ValueError("Invalid value for `id`, must be a follow pattern or equal to `/^[A-Za-z0-9-_]{0,50}$/`")

        self._id = id

    @property
    def customer_account_id(self):
        """
        Gets the customer_account_id of this InlineResponse2001CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in partner's system.

        :return: The customer_account_id of this InlineResponse2001CustomerAccountInfo.
        :rtype: str
        """
        return self._customer_account_id

    @customer_account_id.setter
    def customer_account_id(self, customer_account_id):
        """
        Sets the customer_account_id of this InlineResponse2001CustomerAccountInfo.
        Customer Account Id is a unique identifier assigned to the account in partner's system.

        :param customer_account_id: The customer_account_id of this InlineResponse2001CustomerAccountInfo.
        :type: str
        """
        if customer_account_id is not None and len(customer_account_id) > 50:
            raise ValueError("Invalid value for `customer_account_id`, length must be less than or equal to `50`")
        if customer_account_id is not None and len(customer_account_id) < 0:
            raise ValueError("Invalid value for `customer_account_id`, length must be greater than or equal to `0`")
        if customer_account_id is not None and not re.search('^[A-Za-z0-9-_]{0,50}$', customer_account_id):
            raise ValueError(
                "Invalid value for `customer_account_id`, must be a follow pattern or equal to `/^[A-Za-z0-9-_]{0,50}$/`")

        self._customer_account_id = customer_account_id

    @property
    def custom_fields(self):
        """
        Gets the custom_fields of this CustomerAccountInfo.

        :return: The custom_fields of this CustomerAccountInfo.
        :rtype: FieldStringMap
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """
        Sets the custom_fields of this CustomerAccountInfo.

        :param custom_fields: The custom_fields of this CustomerAccountInfo.
        :type: FieldStringMap
        """

        self._custom_fields = custom_fields

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, InlineResponse2001CustomerAccountInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
